
Drupal.nodeStackHandler = function() {
  var dragging, settings = Drupal.settings.nodestack, nodestack = $('#block-nodestack-0');

  $('.node').mousedown(function(e) {
    if (e.shiftKey) {
      dragging = {
        target: e.target, id: this.id,
        indicator: $(settings.indicator).find('.title').html(settings[this.id].title).end().appendTo('body').fadeIn()
      };
      dragging.size = Drupal.dimensions(dragging.indicator[0]);
      $(document).mousemove(dragHandler).mouseup(dragEnd);
      return false;
    }
  });
  
  $('.nodestack-item .remove').click(removeItem);
  
  function dragHandler(e) {
    var pos = Drupal.mousePosition(e);
    
    if (dragging.target != e.target) {
      dragging.dropping = e.target == nodestack[0] || $(e.target).parents('#block-nodestack-0').size();
      nodestack[dragging.dropping ? 'addClass' : 'removeClass']('highlight');
      dragging.target = e.target;
    }

    dragging.indicator.css({ left: (pos.x - dragging.size.width - 4) + 'px', top: (pos.y - dragging.size.height - 4) + 'px' });
    
    return false;    
  }
  
  function dragEnd() {
    if (dragging.dropping && !$('li#nodestack-' + dragging.id, nodestack).size()) {
      var item = $(settings.item).attr('id', 'nodestack-' + dragging.id).addClass('nodestack-item').css('opacity', 0.5);
      $('.title', item).html(settings[dragging.id].title).href(settings[dragging.id].url)
      $('.remove', item).click(removeItem);
      item.appendTo($('ul', nodestack));
      
      // Now save to the server
      jQuery.ajax({
        url: settings.addCallback,
        type: 'POST',
        data: $.param({ id: dragging.id }),
        success: function() {
          item.animate({ opacity: 1 }, 'normal');
        },
        error: function() {
          item.animate({ opacity: 0 }, function() {
            item.remove();
          });
        }
      });
    }
    
    $(document).unmousemove(dragHandler).unmouseup(dragEnd);
    nodestack.removeClass('highlight');
    dragging.indicator.fadeOut('normal', function() { 
      $(this).remove();
    });
    dragging = undefined;
  }
  
  function removeItem() {
    var item = $(this).parents('.nodestack-item').animate({ opacity: 0.5 });
    jQuery.ajax({
      url: settings.removeCallback,
      type: 'POST',
      data: $.param({ id: item[0].id }),
      success: function() {
        item.animate({ opacity: 0 }).slideUp('normal', function() {
          item.remove();
        });
      },
      error: function() {
        item.animate({ opacity: 1 });
      }
    });
    
    return false;
  }
}

if (Drupal.jsEnabled) {
  $(document).ready(Drupal.nodeStackHandler);
}
